// Test code
writeln(TurtleGraphics.Test());

// Regular pentagon
var t = new TurtleGraphics.Turtle();
with ( t ) {
  var N = 5;
  for (var i = 0; i != N; ++i) {
    Move(1);
    Turn(360 / N);
  }
}

// Regular 3- to 10-gons on white backbround
var t = new TurtleGraphics.Turtle();
//writeObject('t = ', t);
with ( t ) {
  Clean("white");
  for (var n = 3; n <= 10; ++n) {
    for (var i = 0; i != n; ++i) {
      Move(1);
      Turn(360 / n);
    }
  }
  writeln(log);
}

// Turtles at the vertices of a slanted 11-gon
var t2 = new TurtleGraphics.Turtle({ unit: 100, origin: 'bc' });
with ( t2 ) {
  Clean("white");
  PU(); M(-.5); T(90); M(.25); T(-90); PD();
  Roll(-45);
  var n = 11;
  for (var i = 0; i != n; ++i) {
    Move(1);
    Turn(360 / n);
    DrawTurtle("blue");
  }
  writeln(log);
}

// Turtles 
var t3 = new TurtleGraphics.Turtle({ unit: 50, origin: 'bl' });
with ( t3 ) {
  Clean();
  Turn(Math.atan2(context.canvas.height, context.canvas.width)/Degree);
  Dive(30);
  PU(); Move(.4);
  DrawTurtle("red");
  for (var i = 0; i != 12; ++i) {
    Move(1);
    Roll(30);
    DrawTurtle("blue");
  }
  writeln(log);
}

var fek = new TurtleGraphics.Turtle({ unit: 40, origin: 'cc' });
with ( fek ) {
  var phi = Math.atan(2*Math.sqrt(2)) / Degree;
  function Rh(d) { fek.Segment(d,  60, phi); }
  function Lh(d) { fek.Segment(d, -60, phi); }
  Clean();
  for (var i = 0; i != 2; ++i) {
    Rh(2); Lh(1); Rh(1); Lh(1); Lh(2); Rh(1); Lh(1); Rh(1);
  }
  writeln(log);
}

var so = new TurtleGraphics.Turtle({ origin: 'cl' });
with ( so ) {
  Clean();

  PU(); M(.5); DT("lime"); PD();
  T(-30); M(1); M(1); T(90); T(30); M(1); T(90);
  DT("blue");

  PU(); T(180); M(1); PD(); DT("lime");
  R(180); T(30); S(2, 180, 120); S(1, 0, 90); R(0);
  DT("blue");

  PU(); T(180); M(1); PD(); DT("lime");
  R(180); T(30); S(2, 180, 120); S(1, 0, 0);
  DT("blue");

  PU(); T(-90); M(1); PD(); DT("lime");
  S(2, 0, 120); S(1, 0, 0);
  DT("blue");

  PU(); M(-1); T(-120); M(1); PD(); DT("lime");
  S(1, 0, 120); S(2, 0, 0);
  DT("blue");

  writeln(log)
}

var spc = new TurtleGraphics.Turtle({ origin: 'bl' });
with ( spc ) {
  //Clean();

  PU(); T(45); M(1.5); T(-45); DT("lime"); PD();
  T(-30); S(1, 0, 120); S(1, 0, 90); S(Math.sqrt(3), 0, 150); S(1, 0, 30);
  DT("blue");

  PU(); M(2); PD(); DT("lime");
  S(2, 0, 120); S(1, 0, 90); S(Math.sqrt(3), 0, 150);
  DT("blue");

  PU(); M(3); PD(); DT("lime");
  S(1, 0, 90); S(Math.sqrt(3), 0, 150); S(2, 0, 120);
  DT("blue");

  PU(); M(2); PD(); DT("lime");
  S(Math.sqrt(3), 0, 150); S(2, 0, 120); S(1, 0, 90);
  DT("blue");

  writeln(log)
}
